/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.0
        Device            :  PIC12F1822
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"

typedef struct {
    unsigned char r;
    unsigned char g;
    unsigned char b;
} rgb24;

rgb24 data[] = {
    {4, 0, 0},
    {4, 4, 0},
    {0, 4, 0},
    {0, 0, 4},
    {4, 0, 0},
    {4, 4, 0},
    {0, 4, 0},
    {0, 0, 4},
    {4, 0, 0},
    {4, 4, 0},
    {0, 4, 0},
    {0, 0, 4},
    {4, 0, 0},
    {4, 4, 0},
    {0, 4, 0},
    {0, 0, 4},
    {1, 1, 1}
};

void send_bit0(void)
{
    // 0.5, 2.0us
    // 4, 16 insts
#asm
    movlb 2 ; BANK 2
    bsf 12, 2   ; LATA, 2
    nop
    movlb 2 ; BANK 2
    bcf 12, 2   ; LATA, 2
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
#endasm
}

void send_bit1(void)
{
    // 1.2, 1.3us
    // 10, 10 insts
#asm
    movlb 2 ; BANK 2
    bsf 12, 2   ; LATA, 2
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    movlb 2 ; BANK 2
    bcf 12, 2   ; LATA, 2
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
#endasm
}

void send_byte(unsigned char b)
{
    if (b & 0x80) {
        send_bit1();
    } else {
        send_bit0();
    }
    if (b & 0x40) {
        send_bit1();
    } else {
        send_bit0();
    }
    if (b & 0x20) {
        send_bit1();
    } else {
        send_bit0();
    }
    if (b & 0x10) {
        send_bit1();
    } else {
        send_bit0();
    }
    if (b & 0x08) {
        send_bit1();
    } else {
        send_bit0();
    }
    if (b & 0x04) {
        send_bit1();
    } else {
        send_bit0();
    }
    if (b & 0x02) {
        send_bit1();
    } else {
        send_bit0();
    }
    if (b & 0x01) {
        send_bit1();
    } else {
        send_bit0();
    }
}
/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    while (1)
    {
        // Add your application code
        int i = 0;
        rgb24 curr = data[i];
        while (curr.r != 1) {
            unsigned char p;
            p = curr.g;
            send_byte(p);
            p = curr.r;
            send_byte(p);
            p = curr.b;
            send_byte(p);
            curr = data[++i];
        }
        __delay_us(70);
    }
}

/**
 End of File
*/